// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robot_pick_obj_msg:srv/TaskExecution.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_PICK_OBJ_MSG__SRV__DETAIL__TASK_EXECUTION__STRUCT_HPP_
#define ROBOT_PICK_OBJ_MSG__SRV__DETAIL__TASK_EXECUTION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Request __attribute__((deprecated))
#else
# define DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Request __declspec(deprecated)
#endif

namespace robot_pick_obj_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct TaskExecution_Request_
{
  using Type = TaskExecution_Request_<ContainerAllocator>;

  explicit TaskExecution_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->target_type = "";
      this->task_type = "";
    }
  }

  explicit TaskExecution_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : target_type(_alloc),
    task_type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->target_type = "";
      this->task_type = "";
    }
  }

  // field types and members
  using _target_type_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _target_type_type target_type;
  using _task_type_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _task_type_type task_type;

  // setters for named parameter idiom
  Type & set__target_type(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->target_type = _arg;
    return *this;
  }
  Type & set__task_type(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->task_type = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Request
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Request
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TaskExecution_Request_ & other) const
  {
    if (this->target_type != other.target_type) {
      return false;
    }
    if (this->task_type != other.task_type) {
      return false;
    }
    return true;
  }
  bool operator!=(const TaskExecution_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TaskExecution_Request_

// alias to use template instance with default allocator
using TaskExecution_Request =
  robot_pick_obj_msg::srv::TaskExecution_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace robot_pick_obj_msg


#ifndef _WIN32
# define DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Response __attribute__((deprecated))
#else
# define DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Response __declspec(deprecated)
#endif

namespace robot_pick_obj_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct TaskExecution_Response_
{
  using Type = TaskExecution_Response_<ContainerAllocator>;

  explicit TaskExecution_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->successful = false;
    }
  }

  explicit TaskExecution_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->successful = false;
    }
  }

  // field types and members
  using _successful_type =
    bool;
  _successful_type successful;

  // setters for named parameter idiom
  Type & set__successful(
    const bool & _arg)
  {
    this->successful = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Response
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robot_pick_obj_msg__srv__TaskExecution_Response
    std::shared_ptr<robot_pick_obj_msg::srv::TaskExecution_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TaskExecution_Response_ & other) const
  {
    if (this->successful != other.successful) {
      return false;
    }
    return true;
  }
  bool operator!=(const TaskExecution_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TaskExecution_Response_

// alias to use template instance with default allocator
using TaskExecution_Response =
  robot_pick_obj_msg::srv::TaskExecution_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace robot_pick_obj_msg

namespace robot_pick_obj_msg
{

namespace srv
{

struct TaskExecution
{
  using Request = robot_pick_obj_msg::srv::TaskExecution_Request;
  using Response = robot_pick_obj_msg::srv::TaskExecution_Response;
};

}  // namespace srv

}  // namespace robot_pick_obj_msg

#endif  // ROBOT_PICK_OBJ_MSG__SRV__DETAIL__TASK_EXECUTION__STRUCT_HPP_
